#ifndef CountMetric_INCLUDED
#define CountMetric_INCLUDED

//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : CountMetric.h
//
//   Created : 11/16/98
//   By : Patrick McDaniel
//
//   Description : This class describes one instance of a count generating
//                 performance metric.
//
//   *** Change History ***
//
//   11/16/98 Created File : DPM
//
//////////////////////////////////////////////////////////////////////////////////

// *** Include Files ***

// Project Include Files
#include <Metric.h>

// *** Definitions *** 

// Class Definition CountMetric
class CountMetric : public Metric {

  public: // Public Interface

    //
    // Constructors and Destructors

    CountMetric( int indx );
      // Attribute constructor

    virtual ~CountMetric( void );
      // Destructor

    //
    // Derived Class Methods

    virtual unsigned char *toString( void );
      // Construct a string used for printing.

    //virtual void metricEvent( unsigned long val );
    virtual void metricEvent( double val );
      // update the metric with a given value

    virtual void mark( unsigned long sec, unsigned long usec);
      // trigger the update of the filters based on some time
      // reference

    virtual void markSummary( unsigned long tm );
      // mark the summary statistics of the metric

    //
    // Static Member Functions

  private: // Private Interface and Data

    // 
    // Class Attributes

    //unsigned long markValue;
    double markValue;
      // This is the (short lived) value of the metric

    //unsigned long summaryValue;
    double summaryValue;
      // This is the summary statistic used to calculate summary.

};
// End Class Definition CountMetric

#endif
