#ifndef GnuPlotFileFilter_INCLUDED
#define GnuPlotFileFilter_INCLUDED

//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : GnuPlotFileFilter.h
//
//   Created : 1/29/99
//   By : andros
//
//   Description : This class describes a filter that produces a file in
//                 gnuplot format for the metrics collected.
//
//   *** Change History ***
//
//
//////////////////////////////////////////////////////////////////////////////////

// *** Include Files ***
#include <stdio.h>
#include <sys/time.h>
// Project Include Files
#include <MetricFilter.h>

// *** Definitions *** 

// Class Definition GnuPlotFileFilter
class GnuPlotFileFilter : public MetricFilter {

  public: // Public Interface

    //
    // Constructors and Destructors

    GnuPlotFileFilter( char *nm );
      // Attribute Constructor

    virtual ~GnuPlotFileFilter( void );
      // Destructor

    //
    // Access Functions

    //
    // Derived Class Methods

    virtual void mark( int metID, unsigned long sec,unsigned long usec, double val );
      // update current filter state with new values

    virtual void markSummary( int metID, unsigned long tm, double val );
      // mark the summary statistics of the metric

    // 
    // Member Functions

  private: // Private Attributes

    // 
    // Class Attributes

    char *FileName;
    FILE *file_;
#if !defined(OLD)
#define MRKARRAYSIZE 1024
    float mrkarray_[2][MRKARRAYSIZE];
    int mrkarray_index_;
#endif /*OLD*/
      //FileName holds data in gnuplot format

    struct timeval start_;
      // initialized in constructor, holds data collection start time.
    struct timeval then_;
      // initialized in constructor, holds previous mark time.

};
// End Class Definition GnuPlotFileFilter

#endif
