#ifndef Listable_INCLUDED
#define Listable_INCLUDED

//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : Listable.h
//
//   Created : 09/23/98
//   By : Patrick McDaniel
//
//   Description : This class describes an abstract interface for including
//                 an object in various lists (LinkedList/HashTables).
//
//   *** Change History ***
//
//   09/23/98 Created File : DPM
//
//////////////////////////////////////////////////////////////////////////////////

// *** Include Files ***

// Project Include Files

// Class Definition Listable
class Listable {

  public: // Public Interface

    // 
    // Abstract Member Functions

    virtual unsigned int hashValue( void ) = 0;
      // Hash value of object.

    virtual void *listValue( void ) = 0;
      // Get the ordering list value (not to be interpreted)

    virtual int compareListValues( void *value ) = 0;
      // Make a comparison between the two values.

    virtual unsigned char *toString( void ) = 0;
      // Construct a string used for printing.

    virtual int typeOf( void ) = 0;
      // This returns the type of object (listable def)

    // 
    // Abstract Static Methods

    static unsigned int hashValue( void *value );
      // Hash value of object. (requires char * value)

  private: // Private Interface and Data

    // 
    // Class Attributes

};
// End Class Definition Listable

#endif
