#ifndef MaxMetric_INCLUDED
#define MaxMetric_INCLUDED

//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : MaxMetric.h
//
//   Created : 11/16/98
//   By : Patrick McDaniel
//
//   Description : This class describes one instance of a maximum value
//                 performance metric.
//
//   *** Change History ***
//
//   11/16/98 Created File : DPM
//
//////////////////////////////////////////////////////////////////////////////////

// *** Include Files ***

// Project Include Files
#include <Metric.h>

// *** Definitions *** 

// Class Definition MaxMetric
class MaxMetric : public Metric {

  public: // Public Interface

    //
    // Constructors and Destructors

    MaxMetric( int indx );
      // Attribute constructor

    virtual ~MaxMetric( void );
      // Destructor

    //
    // Access Functions

    //
    // Derived Class Methods

    virtual unsigned char *toString( void );
      // Construct a string used for printing.

    virtual void metricEvent( double val );
      // update the metric with a given value

    //virtual void mark( unsigned long tm );
    virtual void mark( unsigned long sec, unsigned long usec);
      // trigger the update of the filters based on some time
      // reference

    virtual void markSummary( unsigned long tm );
      // mark the summary statistics of the metric

    //
    // Static Member Functions

  private: // Private Interface and Data

    // 
    // Class Attributes

    double maxValue;
      // This is the (short lived) value of the metric

    double summaryMaxValue;
      // This is the summary statistic used to calculate summary.

};
// End Class Definition MaxMetric

#endif
