#ifndef Monitor_INCLUDED
#define Monitor_INCLUDED

//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : Monitor.h
//
//   Created : 10/27/98
//   By : Patrick McDaniel
//
//   Description : This class describes one defines a interface for a
//                 generic performance monitor.
//
//   *** Change History ***
//
//   10/27/98 Created File : DPM
//   10/27/98 Continued performance monitor developement : DPM
//
//////////////////////////////////////////////////////////////////////////////////

// *** Include Files ***

// Project Include Files
#include <HashTable.h>

// *** Definitions ***

// Class Identifier IDS
#define TYPE_METRIC        0x0010
#define TYPE_METRIC_FILTER 0x0011
#if !defined (SEC_AND_USEC)
#define USEC(st,fi) (((fi)->tv_sec-(st)->tv_sec)*1000000+ \
                ((fi)->tv_usec-(st)->tv_usec))
#endif /*!SEC_AND_USEC*/


// Forward References
class Metric;

// Class Definition Monitor
class Monitor {

  public: // Public Interface

    //
    // Constructors and Destructors

    Monitor( void );
      // Default constructor

    ~Monitor( void );
      // Destructor

    // 
    // Member Functions

    Metric * registerMetric( int metIdx, int typ );
      // Register a new collection metric with the monitor.

   // void mark( unsigned long tm );
    void mark( unsigned long sec, unsigned long usec);
      // trigger the update of the filters based on some time
      // reference

    void markSummary( unsigned long tm );
      // mark the summary statistics of the metric

    void metricEvent( int idx, double val );
      // Register an event with monitor.

    Metric *FindMetric(int idx);
      // return a pointer to the Metric referenced by idx or NULL

  private: // Private Interface and Data

    //
    // Class Attributes

    List *metrics;
      // This is a table of metrics used to generate performance statistics.

};
// End Class Definition Monitor

#endif
