/*
 * Copyright 1999
 * Center for Information Technology Integration (CITI)
 * Information Technology Division
 * The University of Michigan
 * Ann Arbor
 * info@citi.umich.edu
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies of the software and modified versions or derivative works
 * thereof and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the names of
 * CITI or THE UNIVERSITY OF MICHIGAN not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS." CITI and THE UNIVERSITY OF MICHIGAN
 * DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL
 * CITI OR THE UNIVERSITY OF MICHIGAN BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/////////////////////////////////////////////////////////////////////////////////
//
//
//   File : Support.cpp
//
//   Created : 10/07/98
//   By : Patrick McDaniel
//
//   Description : (See Support.h for class description)
//
//   *** Change History ***
//
//   10/07/98 Created File : DPM
//
//////////////////////////////////////////////////////////////////////////////////

// Include Files
#include <iostream.h>

// Project Include Files
#include <Support.h>

// Definitions

//////////////////////////////////////////////////////////////////////////////////
//
// Function     : kdhsimAssert
// Description  : Assert on a expression at line/file
//
// Inputs       : expr - expression to assert
//                txt - text to display on failure
//                lineno - line number of assert
//                file - file of assert
// Outputs      : none

void SupAssert( int expr, const char *txt, int lineno, const char *file )
{
    // If assert failed, return
    if ( expr ) return;

    // Failure, print to standard error and exit
    cerr << "ASSERT at line " << lineno << ", file " << file << " -> " 
         << txt << endl;
    exit( 0 );
}

