/*
 * Copyright 1995
 * Center for Information Technology Integration (CITI)
 * Information Technology Division
 * The University of Michigan
 * Ann Arbor
 * info@citi.umich.edu
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies of the software and modified versions or derivative works
 * thereof and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the names of
 * CITI or THE UNIVERSITY OF MICHIGAN not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS." CITI and THE UNIVERSITY OF MICHIGAN
 * DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL
 * CITI OR THE UNIVERSITY OF MICHIGAN BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* 
 * Created by: andros@citi.umich.edu 4/2/99
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/time.h>
#include <unistd.h>

char msg[1500];
char lastpkt[1500];

#define USEC(st,fi) (((fi)->tv_sec-(st)->tv_sec)*1000000+ \
		((fi)->tv_usec-(st)->tv_usec))

int debug = 1; /*toggle for debug printf*/

main(int ac, char **av)
{
int fd,len,n,i,kbps,sum,notyet;
struct sockaddr_in saddr;
char buf[64];
struct hostent *hp;
struct timeval start,mark,interval;
long kbps_usec,interval_usec;
long onesec = 1000000;
long seqno;
long seq_no;
int usec_between_send;
int kilobits = 1000; /* not 1024 */
int persec,msgend,maintain_pkt_size,do_once;
int lastpktlen,done;
int rcvbufsize;
int rcvbufret;
int rcvblen;
int sndbufsize;
int sndbufret;
int sndblen;

    if(ac < 6){
	printf("usage: <hostname>\n       <port(from gen_recv)>\n       <desired output in kbps (1000 bits/sec)>\n       <starting packet size (4 bytes = default,1490 max)>\n       <usec between sends, per second(1000 = maximum,20 =  minimum>\n");
	exit(0);
    }

   kbps = atoi(av[3]);
   usec_between_send = atoi(av[5]);
   if((usec_between_send < 20) || (usec_between_send > 1000))
       usec_between_send = 1000;


/* construct the max size ip packet */
    for(i=0+sizeof(long);i<1500-sizeof(long);i++) msg[i] = 'A';
    /* ensure strlen() will be reasonable...*/
    msg[1500] = '\0';
	    	
    for(i=0+sizeof(long);i<1500-sizeof(long);i++) lastpkt[i] = 'A';
    /* ensure strlen() will be reasonable...*/
    lastpkt[1500] = '\0';
	    	
    if ((fd = socket(PF_INET, SOCK_DGRAM, 0)) < 0) {
	perror("socket");
	exit(1);
    }

#if 0
    rcvbufsize = 262144;
    sndbufsize = 262144;
    if(setsockopt(fd,SOL_SOCKET,SO_SNDBUF,&sndbufsize,sizeof(int))<0){
	perror("setsocktop");
    }
    if(setsockopt(fd,SOL_SOCKET,SO_RCVBUF,&rcvbufsize,sizeof(int))<0){
	perror("setsocktop");
    }

    sndblen = rcvblen = sizeof(int);
    if(getsockopt(fd,SOL_SOCKET,SO_SNDBUF,&sndbufret,&sndblen)<0){
	perror("getsocktop");
    }
    printf("SO_SNDBUF: %d\n",sndbufret);
    if(getsockopt(fd,SOL_SOCKET,SO_RCVBUF,&rcvbufret,&rcvblen)<0){
	perror("getsocktop");
    }
    printf("SO_RCVBUF: %d\n",rcvbufret);
#endif

    hp = gethostbyname(av[1]);
    if(!hp){
	perror("gethostbyname");
	exit(1);
    }

    saddr.sin_family = hp->h_addrtype;;
    saddr.sin_port = htons(atoi(av[2]));
    bcopy((char *)hp->h_addr,(char *)&saddr.sin_addr.s_addr,hp->h_length);

   /* start with a 4 byte message */ 
    if(atoi(av[4])<1400)
	msgend = atoi(av[4]);
    else
        msgend = 4;
    msg[msgend] = '\0';
    len = strlen(&msg[sizeof(long)])+sizeof(long);
    sum = 0;
    seqno = 0;
    persec = 1;
    do_once = 1;
    maintain_pkt_size = 0;
    while(1){
        gettimeofday(&start,NULL);

        interval.tv_sec = start.tv_sec;
        interval.tv_usec = start.tv_usec;

	if(debug)printf("%d bits sent    seq_no: %d \n",sum * 8,ntohl(seq_no));
	notyet = 1;
	sum = 0;
	done = 0;
	/* if we are not producing enough bandwidth, increase
	 * the message size by two bytes.
	 */
	if(!maintain_pkt_size && (msgend < 1500)){
            msg[msgend] = 'A';
	    msgend++;
	    msgend++;
	    msg[msgend] = '\0';
	    len = strlen(&msg[sizeof(long)]) + sizeof(long);
	    if(debug)printf("msg len: %d\n",len);
	}
	/* guarentee that we are a little bit over requested kbps */
	if((maintain_pkt_size == 1) && (msgend + 2 < 1500) && do_once){
            msg[msgend] = 'A';
	    msgend = msgend + 2;
	    msg[msgend] = '\0';
	    len = strlen(&msg[sizeof(long)]) + sizeof(long);
	    if(debug)printf("msg len: %d\n",len);
	    do_once = 0;
	}
	persec = 0;
	while(notyet){
	    persec++;
            gettimeofday(&mark,NULL);
	    kbps_usec = USEC(&start,&mark);
            if(kbps_usec < onesec){ /* if less than a second has gone by */
	    interval_usec = USEC(&interval,&mark); 
	    if(interval_usec < usec_between_send){ 
		/* do nothing. this spreads the requested kbps
		 * more evenly over the sec
		 */
	    }
	    else{
	       interval.tv_sec = mark.tv_sec;
	       interval.tv_usec = mark.tv_usec;

	    /* send exactly whats needed in last packet */
		if((((sum * 8)+(len * 8)) > (kbps * kilobits)) && !done){
		    lastpktlen = ((kbps*kilobits) - (sum * 8))/8;
		/*  printf("BEEN SENT: %d\n",(sum * 8));
		    printf("LASTPKELEN : %d\n",lastpktlen);
		*/
		    if(lastpktlen > 0 && lastpktlen < 1500){
		        seq_no = htonl(seqno);
		        (void)bcopy((char *)&seq_no,lastpkt,sizeof(seq_no));
	                if (sendto(fd, msg,lastpktlen, 0,(struct sockaddr *)&saddr, sizeof saddr) < 0) {
	                    perror("sendto");
	                    exit(1);
                        }
		    }
		    done = 1;
		    sum += lastpktlen;
		    seqno++;
		}else{

                    if((kbps * kilobits) > (sum * 8)){ /* send kbps *1024 bits */
		        seq_no = htonl(seqno);
		        (void)bcopy((char *)&seq_no,msg,sizeof(seq_no));
	                if (sendto(fd, msg, len, 0,(struct sockaddr *)&saddr, sizeof saddr) < 0) {
	                    perror("sendto");
	                    exit(1);
                        }
	                sum += len;
		        seqno ++;
	            }else{
		/* so for the number of packets sent in the past second,
		 * the current packet size fits in the desired kbps.
		 * now up the current packet size by 50bytes so that 
		 * we are guarenteed to be a bit over desired kbps
		 */
		        maintain_pkt_size = 1;
		    }
		}
	    }
	    }else{ /*kbps_usec < onesec*/
	        notyet = 0;
	    }
	}
    }
    exit(0);
}
